#include <iostream>
#include <math.h>
#include <cstdlib>
#include <ctime>
#include <fstream>

using namespace std;

int htoi(char *c_arr)
{
	return (int)c_arr[0]*256+(int)c_arr[1]*16;
}

int main(int argc, char **argv)
{
	if(argc < 2)
	{
		cout << "Usage: dwt <signallenght> [file]" << endl;
		return 1;
	}
	cout.setf(ios::fixed,ios::floatfield);
	cout.precision(4);
	srand((unsigned)time(NULL));
	int siglen = atoi(argv[1]);
	double* signal;
	double *c, *d;
	double *decomp;
	int predefined[] = {1,3,5,11,12,13,0,1};
	if(argc == 3) {
		fstream file;
		file.open(argv[2],ios::in|ios::binary|ios::ate);
		if(file.is_open()) {
			siglen = ((int)file.tellg()-44)/2;
			signal = new double[siglen];
			c = new double[siglen];
			decomp = new double[siglen];
			file.seekg(45,ios::beg);
			int count = 0;
			while(!file.eof()) {
				char *buffer = new char[2];
				file.read(buffer,2);
				int number = htoi(buffer);
				//cout << number << endl;
				signal[count] = (double)number/32768.;
				count++;
			}
			cout << "count: " << count << endl;
		}
		else {
			cout << "Couldn't open file" << endl;
			return 1;
		}
	}
	else
	{
		signal = new double[siglen];
		c = new double[siglen];
		decomp = new double[siglen];
		for(int i=0;i<siglen;i++)
		{
			signal[i] = rand()%100;
			//signal[i] = predefined[i];
			//signal[i] = 1.3*sin((double)i/20.) + 0.5*cos((double)i/5.);
		}
	}
	for(int i=0;i<siglen;i++)
	{
		c[i] = signal[i];
		cout << "\t" << signal[i] ;
	}
	cout << endl;

	int j=1;
	int c_size = siglen;
	while(true)
	{
		int dim;
		if((int)ceil((double)c_size/2.)%2 == 0) {
			dim = (int)ceil((double)c_size/2.);
		} else
		{
			dim = (int)ceil((double)c_size/2.)+1;
		}
		double *new_c = new double[dim];
		d = new double[dim];
		new_c[dim-1] = 0;
		d[dim-1] = 0;
		cout << "Lo:\t";
		for(int k=1;2*k-1 < c_size;k++) {
			new_c[k-1] = sqrt(2.)*(c[2*k-1]+c[2*k-2])/2.;
			//cout << new_c[k-1] << "=(" << c[2*k-1] << "+" << c[2*k-2] << ") ";
			cout << new_c[k-1] << "\t";
		}
		cout << endl;
		cout << "Hi:\t";
		for(int k=1;2*k-1 < c_size;k++) {
			d[k-1] = sqrt(2.)*(c[2*k-2]-c[2*k-1])/2.;
			decomp[c_size/2+k-1] = d[k-1]; 
			//cout << d[k-1] << "=(" << c[2*k-2] << "-" << c[2*k-1] << ") ";
			cout << d[k-1] << "\t";
		}
		cout << endl;
		delete[] c;
		delete[] d;
		c = new_c;
		if((int)ceil((double)c_size/2.) == 1)	{
			break;
		}
		else {
			c_size = dim;
		}
	}
	decomp[0] = c[0];
	/*for(int i=0;i<siglen;i++)
	{
		if(decomp[i] < 0.1 && decomp[i] > -0.1) {
			decomp[i] = 0.;
		}
		cout << "\t" << decomp[i];
	}
	cout << endl;*/
	
	//Reconstruction:
	j=1;
	while((int)pow(2,j) <= siglen)
	{
		double *new_c = new double[(int)pow(2,j)];
		cout << "Level" << j  << ":\t";
		int d_offset = pow(2,j-1);
		for(int k=1;2*k <= pow(2,j);k++) {
			new_c[2*k-1] = sqrt(2.)*(decomp[k-1]-decomp[d_offset+(k-1)])/2.;
			new_c[2*k-2] = sqrt(2.)*(decomp[k-1]+decomp[d_offset+(k-1)])/2.;
			//cout << new_c[2*k-2] << "\t" << new_c[2*k-1] << "=(" << decomp[k-1] << "-" << decomp[k] << ") ";
			cout << new_c[2*k-2] << "\t" << new_c[2*k-1] << "\t";
		}
		cout << endl;
		delete[] c;
		c = new_c;
		for(int k=1;k <= pow(2,j);k++) {
			decomp[k-1] = c[k-1];
			//cout << "decomp[" << k-1 << "]" << "=" << c[k-1] << "\t";
		}
		//cout << endl;
		j++;
	}
	for(int i=0;i<siglen;i++)
	{
		cout << "\t" << decomp[i]-signal[i];
	}
	cout << endl;
	return 0;
}
