#include <iostream>
#include <cstdlib>
#include <math.h>
#include <sstream>
using namespace std;

char* raster_code(int num, int width, int height)
{
	//cout << "Number: " << num << " - " << width << " - " << height << endl;
	if(width <= 2 || height <= 2) {
		if(num >= 1 && num <= 4) {
			char *rc = new char[1];
			stringstream ss;
			ss << num;
			ss >> rc;
			return rc;
		}
		else {
			return NULL;
		}
	}
	int code_length = (width > height) ? log2(width) : log2(height);
	char *code = new char[code_length];
	int row = (num-1)/width;
	row %= height/2;
	if((num-1)%width < width/2 && num <= width*height/2) {
		code[0] = '1';
		num -= width*row/2;
	}
	else {
		if((num-1)%width >= width/2 && num <= width*height/2) {
			code[0] = '2';
			num -= width*(row+1)/2;
		}
		else {
			if((num-1)%width < width/2 && num > width*height/2) {
				code[0] = '3';
				num -= width*height/2;
				num -= width*row/2;
			}
			else {
				if((num-1)%width >= width/2 && num > width*height/2) {
					code[0] = '4';
					num -= width*height/2;
					num -= width*(row+1)/2;
				}
			}
		}
	}
	if(num != 0) {
		char *recursive_code = raster_code(num,width/2,height/2);
		if(recursive_code == NULL) {
			return NULL;
		}
		for(int i=1;i<code_length;i++) {
			code[i] = recursive_code[i-1];
		}
		delete[] recursive_code;
	}
	return code;
}

int raster_code_decode(char *code, int width, int height)
{
	int code_length = (width > height) ? log2(width) : log2(height);
	int sum = 0;
	char num[1];
	for(int i=0;i<code_length;i++) {
		num[0] = code[i];
		//cout << "code " << i << ": " << code[i] << endl;
		sum += (atoi(num)-1)*width*height/pow(4,i+1);
	}
	return sum;
}

void raster_sort(double *arr, int length, int width, int height)
{
	if(length != width*height) {
		return;
	}
	double *copy = new double[length];
	for(int i=0;i<length;i++) {
		copy[i] = arr[i];
	}
	for(int i=0;i<length;i++) {
		char *rcode = raster_code(i+1,width,height);
		if(rcode == NULL) {
			for(int i=0;i<length;i++) {
				 arr[i] = copy[i];
			}
			cout << "return" << endl;
			delete[] rcode;
			delete[] copy;
			return;
		}
		int new_index = raster_code_decode(rcode,width,height);
		delete[] rcode;
		//cout << i << ": " << new_index << endl;
		arr[new_index] = copy[i];
	}
	delete[] copy;
	return;	
}

void inv_raster_sort(double *arr, int length, int width, int height)
{
	if(length != width*height) {
		return;
	}
	double *copy = new double[length];
	for(int i=0;i<length;i++) {
		copy[i] = arr[i];
	}
	for(int i=0;i<length;i++) {
		char *rcode = raster_code(i+1,width,height);
		if(rcode == NULL) {
			for(int i=0;i<length;i++) {
				 arr[i] = copy[i];
			}
			cout << "return" << endl;
			delete[] rcode;
			delete[] copy;
			return;
		}
		int new_index = raster_code_decode(rcode,width,height);
		delete[] rcode;
		//cout << i << ": " << new_index << endl;
		arr[i] = copy[new_index];
	}
	delete[] copy;
	return;	
}
